/*!
 * @file BufferedReader.cc
 * @brief եɤ߹ߥХåե()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-01-26, 
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#include <basic.h>
#include <bstdlib.h>
#include "BufferedReader.h"

int BufferedReader::read(B* target, int size)
{
  W rsize, err, len;
  int rem = size;
  
  if (isEOF()){
    return 0;
  }

  if (blen - bcur >= rem){
    // ХåեΥԡǻ­
    memcpy(&(target[size-rem]), &(buff[bcur]), rem);
    bcur += rem;
    return size;
  }

  if (blen - bcur > 0){
    // ƬʬХåե饳ԡ
    memcpy(&(target[size-rem]), &(buff[bcur]), blen - bcur);
    rem -= (blen - bcur);
  }

  if (rem <= bufsize){
    // ȾʬХåե
    err = rea_rec(filedes, offset, buff, bufsize, &rsize, NULL);
    if (err < 0){
      throw FileReadException(filedes, err);
    }
    if (rsize <= bufsize){
      blen = rsize;
      bcur = ((rem <= blen) ? rem : blen);
      memcpy(&(target[size-rem]), buff, bcur);
      offset += rsize;
//      eof_state = true;
      return size - (rem - bcur);
    }
    else {
      blen = bufsize;
      bcur = rem;
      memcpy(&(target[size-rem]), buff, bcur);
      offset += bufsize;
      return size;
    }
  }
  else {
    // Хåե𤵤ľɤ߹
    blen = bcur = 0;
    err = rea_rec(filedes, offset, &(target[size-rem]), rem, &rsize, NULL);
    if (err < 0){
      throw FileReadException(filedes, err);
    }
    if (rsize <= rem){
      offset += rsize;
//      eof_state = true;
      return size - (rem - rsize);
    }
    else {
      offset += rem;
      return size;
    }
  }
}

int BufferedReader::skip(int size)
{
  W rsize, err;
  int rem = size;

  if (isEOF()){
    return 0;
  }

  if (blen - bcur >= rem){
    bcur += rem;
    return size;
  }

  if (blen - bcur > 0){
    rem -= (blen - bcur);
  }
  bcur = blen = 0;

  err = rea_rec(filedes, offset, 0, 0, &rsize, NULL);
//  printf("rsize = %d, offset = %d, blen = %d, bcur = %d\n", rsize, offset, blen, bcur);
  if (err < 0){
    throw FileReadException(filedes, err);
  }
  else if (rsize <= rem){
    offset += rsize;
//    eof_state = true;
    return size - (rem - rsize);
  }

  offset += rem;
  return size;
}
