/*!
 * @file Exception.h
 * @brief 㳰
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2005-02-20
 *
 * Copyright (C) 2005, Yashiro Takeshi
 */

#ifndef EXCEPTION_H
#define EXCEPTION_H

#include <basic.h>

//! 㳰
/*!
 * 㳰δ쥯饹Ǥ
 */
class Exception {

 protected:
  //! 顼ֹ(ƥॳƤӽФ)
  W err;

 public:
  //! 󥹥ȥ饯
  /*!
   * 㳰ޤ
   * @param e 顼ֹ(ƥॳƤӽФ)
   */
  Exception(W e) : err(e) {}

  //! 顼ɤμ
  /*!
   * 顼(ƥॳƤӽФ)ޤ
   * @return 顼ֹ
   */
  W getErrorCode() const {
    return err;
  }

};

//! ե㳰
/*!
 * եϤ㳰ɽ饹Ǥ
 */
class FileException : public Exception {

 protected:
  //! եǥץ
  W filedes;

 public:
  //! 󥹥ȥ饯
  /*!
   * 㳰ޤ
   * @param fd եǥץ
   * @param e 顼ֹ(ƥॳƤӽФ)
   */
  FileException(W fd, W e) : Exception(e), filedes(fd) {}

  //! եǥץμ
  /*!
   * 㳰ȯեǥץ֤ޤ
   * @return եǥץ
   */
  W getFileDescripter() const {
    return filedes;
  }
};

//! ե륪ץ㳰
/*!
 * ե륪ץ㳰ɽ饹Ǥ
 */
class FileOpenException : public FileException {

 public:
  //! 󥹥ȥ饯
  /*!
   * 㳰ޤ
   * @param fd եǥץ
   * @param e 顼ֹ(ƥॳƤӽФ)
   */
  FileOpenException(W fd, W e) : FileException(fd, e) {}
};

//! եɤ߹㳰
/*!
 * եɤ߹߻㳰ɽ饹Ǥ
 */
class FileReadException : public FileException {

 public:
  //! 󥹥ȥ饯
  /*!
   * 㳰ޤ
   * @param fd եǥץ
   * @param e 顼ֹ(ƥॳƤӽФ)
   */
  FileReadException(W fd, W e) : FileException(fd, e) {}
};

//! ե񤭹㳰
/*!
 * ե񤭹߻㳰ɽ饹Ǥ
 */
class FileWriteException : public FileException {

 public:
  //! 󥹥ȥ饯
  /*!
   * 㳰ޤ
   * @param fd եǥץ
   * @param e 顼ֹ(ƥॳƤӽФ)
   */
  FileWriteException(W fd, W e) : FileException(fd, e) {}
};

//! 桼㳰
/*!
 * 桼㳰ɽ饹Ǥ
 */
class UserException : public Exception {

 public:
  //! 󥹥ȥ饯
  /*!
   * 㳰ޤ
   * @param e 顼ֹ(ƥॳƤӽФ)
   */
  UserException(W e = 0) : Exception(e) {}

};

#endif // EXCEPTION_H
