/**
 * @file OptionParser.cc
 * @brief եιʸ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2008-05-01
 *
 * Copyright (C) 2004-2008, Yashiro Takeshi
 *
 *   BSlide ˤäΤŬ˲Ѥ
 */

#include "OptionParser.h"
#include "tcsliteral.h"
#include <tcode.h>
#include <tctype.h>
#include <bstdio.h>

void OptionParser::putChar(TC ch)
{
  W lang = isTLANGch(ch, &n);
  if (lang > 0){
    currentLang = lang;
    return;
  }
  else if (lang < 0){
    if (lang == -1){
      n = 0;
      currentLang = TSC_SYS;
    }
    return;
  }
  
  n = 0;
  // ѡĲȤ
  switch (currentState){
  case START_OF_LINE:
    if (ch == TK_PCNT && currentLang == TSC_SYS){
      currentState = PERCENT_PARSED;
    }
    else {
      currentState = NONOPTION_LINE;
    }
    break;
  case PERCENT_PARSED:
    if (ch == TK_NL){
      currentState = START_OF_LINE;
      linestack.clear();
      break;
    }
    else if (tc_isspace(ch)){
      break;
    }
    else if (ch == TK_COLN){
      if (linestack.empty()){
        currentState = NONOPTION_LINE;
        break;        
      }
      currentState = COLON_PARSED;
      keytmp = linestack;
      linestack.clear();
      break;
    }
    else if (tc_isalnum(ch) && currentLang == TSC_SYS){
      char buf[2];
      sprintf(buf, "%C", tc_tolower(ch));
      linestack.append(buf);
    }
    break;
  case COLON_PARSED:
    if (ch == TK_NL){
      if (!linestack.empty()){
        opts.insert(std::make_pair(keytmp, linestack));
      }
      currentState = START_OF_LINE;
      keytmp.clear();
      linestack.clear();
      break;
    }
    else if (tc_isspace(ch)){
      break;
    }
    else if (currentLang == TSC_SYS){
      char buf[2];
      sprintf(buf, "%C", ch);
      linestack.append(buf);
    }
    break;
  case NONOPTION_LINE:
    if (ch == TK_NL){
      currentState = START_OF_LINE;
      keytmp.clear();
      linestack.clear();
      break;
    }
    break;
  }
}

